﻿Imports System.Web
Imports System.Web.Services
Imports System.Collections.ObjectModel
Imports System.Web.Script.Serialization
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Json

Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.WebEdition

Public Class info
    Implements System.Web.IHttpHandler, IReadOnlySessionState, IRequiresSessionState

    Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        Dim worldLayer As New ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/Data/Limites_Adm_CAOP_v5_transformed.shp"))
        worldLayer.RequireIndex = False
        worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        worldLayer.DrawingQuality = DrawingQuality.HighSpeed

        'Dim proj4Projection As New Proj4Projection()
        'proj4Projection.InternalProjectionParametersString = proj4Projection.GetEpsgParametersString(27492)
        'proj4Projection.ExternalProjectionParametersString = proj4Projection.GetGoogleMapParametersString()
        'worldLayer.FeatureSource.Projection = proj4Projection

        worldLayer.Open()

        Dim features As Collection(Of Feature) = worldLayer.QueryTools.GetFeaturesWithinDistanceOf(New PointShape(-977580, 4815326), GeographyUnit.Meter, DistanceUnit.Meter, 20, ReturningColumnsType.AllColumns)


        If features.Count > 0 Then
            Dim elems As New FeatureGeometryResponseElements()
            For Each f As Feature In features
                elems.Add(New FeatureGeometryResponseElement(1, f))
            Next

            Dim js As DataContractJsonSerializer = New DataContractJsonSerializer(GetType(FeatureGeometryResponseElements))
            Dim ms As New System.IO.MemoryStream

            js.WriteObject(ms, elems)
            Dim json As String = Encoding.Default.GetString(ms.ToArray())
            context.Response.Write(json)
        Else
            context.Response.Write(String.Empty)
        End If

        
        worldLayer.Close()





    End Sub

    ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return False
        End Get
    End Property

End Class


<DataContract()> _
Class FeatureGeometryResponseElement
    <DataMember()> Public IDMapLayer As Integer
    <DataMember()> Public WKT As String
    <DataMember()> Public ColumnValues As Dictionary(Of String, String)

    <DataMember()> Public FID As String
    Public ElementFeature As Feature

    Public Sub New(ByVal idmaplayer As Integer, ByVal thefeature As Feature)
        Me.IDMapLayer = idmaplayer
        Me.ElementFeature = thefeature
        Me.ColumnValues = thefeature.ColumnValues
        Me.WKT = thefeature.GetWellKnownText()
    End Sub

End Class
Class FeatureGeometryResponseElements
    Inherits Collection(Of FeatureGeometryResponseElement)

End Class
